<?php
/* Autor...:  */
/* Esquema.: PLA_MarcacionRegistro.xml */
/* Generado: 2020-08-18 04:21:29 */

/* Metodos de acceso a los campos de la tabla PLA_MarcacionRegistro */
abstract class BasePLA_MarcacionRegistroBN
{
    /* Campos de la tabla */
    private $s_IdRegistro;    // IdRegistro: ( no definido )
    private $s_Descripcion;    // Descripcion: ( no definido )
    private $i_Secuencia;    // Secuencia: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $i_ObligatorioFlag;    // ObligatorioFlag: ( no definido )
    private $i_IdEquivalente;    // IdEquivalente: ( no definido )

    /* Establece el valor del campo IdRegistro */
    public function setIdRegistro( $s_IdRegistro )
    {
        $this->s_IdRegistro = $s_IdRegistro;
    }

    /* Obtiene el valor del campo IdRegistro */
    public function getIdRegistro()
    {
        return $this->s_IdRegistro;
    }

    /* Establece el valor del campo Descripcion */
    public function setDescripcion( $s_Descripcion )
    {
        $this->s_Descripcion = $s_Descripcion;
    }

    /* Obtiene el valor del campo Descripcion */
    public function getDescripcion()
    {
        return $this->s_Descripcion;
    }

    /* Establece el valor del campo Secuencia */
    public function setSecuencia( $i_Secuencia )
    {
        $this->i_Secuencia = $i_Secuencia;
    }

    /* Obtiene el valor del campo Secuencia */
    public function getSecuencia()
    {
        return $this->i_Secuencia;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo ObligatorioFlag */
    public function setObligatorioFlag( $i_ObligatorioFlag )
    {
        $this->i_ObligatorioFlag = $i_ObligatorioFlag;
    }

    /* Obtiene el valor del campo ObligatorioFlag */
    public function getObligatorioFlag()
    {
        return $this->i_ObligatorioFlag;
    }

    /* Establece el valor del campo IdEquivalente */
    public function setIdEquivalente( $i_IdEquivalente )
    {
        $this->i_IdEquivalente = $i_IdEquivalente;
    }

    /* Obtiene el valor del campo IdEquivalente */
    public function getIdEquivalente()
    {
        return $this->i_IdEquivalente;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdRegistro' => $this->getIdRegistro(),
            'Descripcion' => $this->getDescripcion(),
            'Secuencia' => $this->getSecuencia(),
            'Estado' => $this->getEstado(),
            'ObligatorioFlag' => $this->getObligatorioFlag(),
            'IdEquivalente' => $this->getIdEquivalente(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto PLA_MarcacionRegistroBN desde un RecordSet */
    public static function retrieveByRs( $o_PLA_MarcacionRegistroRs )
    {
        $o_PLA_MarcacionRegistroBN = new PLA_MarcacionRegistroBN();
        $o_PLA_MarcacionRegistroBN->setIdRegistro( $o_PLA_MarcacionRegistroRs[ "IdRegistro" ] );
        $o_PLA_MarcacionRegistroBN->setDescripcion( $o_PLA_MarcacionRegistroRs[ "Descripcion" ] );
        $o_PLA_MarcacionRegistroBN->setSecuencia( ( integer ) $o_PLA_MarcacionRegistroRs[ "Secuencia" ] );
        $o_PLA_MarcacionRegistroBN->setEstado( $o_PLA_MarcacionRegistroRs[ "Estado" ] );
        $o_PLA_MarcacionRegistroBN->setObligatorioFlag( ( integer ) $o_PLA_MarcacionRegistroRs[ "ObligatorioFlag" ] );
        $o_PLA_MarcacionRegistroBN->setIdEquivalente( ( integer ) $o_PLA_MarcacionRegistroRs[ "IdEquivalente" ] );
        return $o_PLA_MarcacionRegistroBN;
    }
}
?>